


;- -------------------------
;-    Windows Registry
;- -------------------------


;/ Conversions, Init, Test, Get
Procedure TopKeyToLong(s.s)
  s = UCase(s)
  Select s
    Case "HKEY_CLASSES_ROOT"
      ProcedureReturn #HKEY_CLASSES_ROOT
    Case "HKEY_CURRENT_USER"
      ProcedureReturn #HKEY_CURRENT_USER
    Case "HKEY_LOCAL_MACHINE"
      ProcedureReturn #HKEY_LOCAL_MACHINE
    Case "HKEY_USERS"
      ProcedureReturn #HKEY_USERS
    Case "HKEY_CURRENT_CONFIG"
      ProcedureReturn #HKEY_CURRENT_CONFIG
    Default
      ProcedureReturn 0
  EndSelect
EndProcedure
Procedure.s TopKeyToStr(s.l)
  Select s
    Case #HKEY_CLASSES_ROOT
      ProcedureReturn "HKEY_CLASSES_ROOT"
    Case #HKEY_CURRENT_USER
      ProcedureReturn "HKEY_CURRENT_USER"
    Case #HKEY_LOCAL_MACHINE
      ProcedureReturn "HKEY_LOCAL_MACHINE"
    Case #HKEY_USERS
      ProcedureReturn "HKEY_USERS"
    Case #HKEY_CURRENT_CONFIG
      ProcedureReturn "HKEY_CURRENT_CONFIG"
    Default
      ProcedureReturn ""
  EndSelect
EndProcedure

Procedure.l IsKeyValueType(Type.l) ;Renvoi 'Vrai' si la valeur passe est bien un type de KeyValue
  Select Type
    Case #REG_SZ
    Case #REG_DWORD
    Case #REG_BINARY
    Case #REG_MULTI_SZ
    Case #REG_EXPAND_SZ
    Default
      ProcedureReturn #False
  EndSelect
  ProcedureReturn #True
EndProcedure
Procedure IniRegKey(*reg.Reg)
  If *reg
    *reg\TopKey   = 0
    *reg\KeyName  = ""
    *reg\KeyValue = ""
  EndIf
EndProcedure

Procedure SplitRegKey(key$, *reg.Reg)
  Protected tmp$
  IniRegKey(*reg)
  
  key$ = Trim(key$)
  If Right(key$, 1) = "@"
    key$ = Left(key$, Len(key$)-1)
  EndIf
  
  tmp$ = StringField(key$, 1, "\")
  *reg\TopKey = TopKeyToLong(tmp$)
  
  If *reg\TopKey
    tmp$ = ReplaceString(key$, tmp$ +"\", "")
    *reg\KeyValue = StringField(tmp$, CountString(tmp$, "\")+1, "\")
    If Len(*reg\KeyValue)
      tmp$ = ReplaceString(tmp$, *reg\KeyValue, "")
    EndIf
    If Right(tmp$,1)="\"
      tmp$ = Left(tmp$, Len(tmp$)-1)
    EndIf
    *reg\KeyName = tmp$
  EndIf
EndProcedure
Procedure.s GlueRegKey(*reg.Reg)
  Protected key$
  
  If *reg
    key$ = TopKeyToStr(*reg\TopKey)
    If key$
      key$ + "\" + *reg\KeyName + *reg\KeyValue
      ProcedureReturn key$
    EndIf
  EndIf
  
  ProcedureReturn ""
EndProcedure

Procedure.l GetTopKey(*reg.Reg)
  If *reg
    ProcedureReturn *reg\TopKey
  EndIf
EndProcedure
Procedure.s GetKeyName(*reg.Reg)
  If *reg
    ProcedureReturn *reg\KeyName
  EndIf
EndProcedure
Procedure.s GetKeyValue(*reg.Reg)
  If *reg
    ProcedureReturn *reg\KeyValue
  EndIf
EndProcedure

Procedure.l IniForQueryToRegKey(*reg.Reg, ComputerName.l, hKey.l, lhRemoteRegistry.l)
  Protected lReturnCode.l
  
  If Left(*reg\KeyName, 1) = "\" 
    *reg\KeyName = Right(*reg\KeyName, Len(*reg\KeyName) - 1) 
  EndIf
  
  If PeekS(ComputerName) = "" 
    ProcedureReturn RegOpenKeyEx_(*reg\TopKey, *reg\KeyName, 0, #KEY_ALL_ACCESS, hKey) 
  Else 
    lReturnCode = RegConnectRegistry_(PeekS(ComputerName), *reg\TopKey, lhRemoteRegistry) 
    ProcedureReturn RegOpenKeyEx_(PeekL(lhRemoteRegistry), *reg\KeyName, 0, #KEY_ALL_ACCESS, hKey) 
  EndIf
EndProcedure


;/ Recuperation de la valeur d'une cle
Macro M_GetRegKeyStrValue()
  Protected reg.Reg
  Protected GetHandle.l, hKey.l, lpData.s, lpcbData.l
  Protected lType.l, lReturnCode.l, lhRemoteRegistry.l, GetValue.s 
  
  SplitRegKey(regKey, reg.Reg)
  GetHandle = IniForQueryToRegKey(reg, @ComputerName, @hKey, @lhRemoteRegistry)
  GetValue = ""
  
  If GetHandle = #ERROR_SUCCESS 
    lpcbData = 255
    lpData = Space(255)
    
    GetHandle = RegQueryValueEx_(hKey, reg\KeyValue, 0, @lType, @lpData, @lpcbData)
    Select lType 
        ; <-- String -->
      Case #REG_SZ 
        
        If GetHandle = 0 
          GetValue = Left(lpData, lpcbData - 1) 
        EndIf
        
        ; <-- Long -->
      Case #REG_DWORD 
        ;Debug "ok"
        If GetHandle = 0
          GetValue = lpData
        EndIf
        
    EndSelect 
  EndIf 
  RegCloseKey_(hKey)
  ProcedureReturn GetValue
EndMacro
ProcedureDLL.s GetRegKeyStrValue(regKey.s)
  Protected ComputerName.s = ""
  M_GetRegKeyStrValue()
EndProcedure
ProcedureDLL.s GetRegKeyStrValue2(regKey.s, ComputerName.s)
  M_GetRegKeyStrValue()
EndProcedure

ProcedureDLL.l GetRegKeyIntValue(regKey.s)
  ProcedureReturn Val(GetRegKeyStrValue(regKey))
EndProcedure
ProcedureDLL.l GetRegKeyIntValue2(regKey.s, ComputerName.s)
  ProcedureReturn Val(GetRegKeyStrValue2(regKey, ComputerName))
EndProcedure


;/ Changement de la valeur d'une cl
Macro M_SetRegKeyValue()
  Protected reg.Reg
  Protected GetHandle.l, hKey.l, lpcbData.l, lType.l, lValue.l
  Protected lpData.s, lReturnCode.l, lhRemoteRegistry.l 
  
  SplitRegKey(regKey, reg.Reg)
  GetHandle = IniForQueryToRegKey(reg, @ComputerName, @hKey, @lhRemoteRegistry)
  
  If GetHandle = #ERROR_SUCCESS
    lpcbData = 255
    lpData = Space(255)
    
    GetHandle = RegQueryValueEx_(hKey, reg\KeyValue, 0, @lType, @lpData, @lpcbData)
    ;lpcbData = 255: lpData = Space(255) ; <-- Ci Bug enlever ce commentaire
    
    If IsKeyValueType(lType) = #False ; La cl n'existe pas
      If Str(Val(vValue)) = Trim(vValue)
        lType = #REG_DWORD
      Else
        lType = #REG_SZ
      EndIf
    EndIf
    
    Select lType
        ; <-- Long -->
      Case #REG_DWORD
        lValue = Val(vValue)
        RegSetValueEx_(hKey, reg\KeyValue, 0, #REG_DWORD, @lValue, 4)
        ; <-- String -->
      Case #REG_SZ
        RegSetValueEx_(hKey, reg\KeyValue, 0, #REG_SZ, @vValue, StringByteLength(vValue) + 1)
    EndSelect
    
    RegCloseKey_(hKey) 
    ProcedureReturn #True
  Else 
    RegCloseKey_(hKey) 
    ProcedureReturn #False
  EndIf
EndMacro
ProcedureDLL.l SetRegKeyValue(regKey.s, vValue.s)
  Protected ComputerName.s = ""
  M_SetRegKeyValue()
EndProcedure 
ProcedureDLL.l SetRegKeyValue2(regKey.s, vValue.s, ComputerName.s)
  M_SetRegKeyValue()
EndProcedure 


;/ Renvoi la sous-cl a l'indice specifie
Macro M_ListRegSubKey()
  Protected GetHandle.l, hKey.l, lpName.s, lpcbName.l, ListSubKey.s
  Protected lpftLastWriteTime.FILETIME, lReturnCode.l, lhRemoteRegistry.l
  Protected reg.Reg
  
  PathAddBackslash_(regKey)
  SplitRegKey(regKey, reg.Reg)
  GetHandle = IniForQueryToRegKey(reg, @ComputerName, @hKey, @lhRemoteRegistry)
  ListSubKey = ""
  
  If GetHandle = #ERROR_SUCCESS
    lpcbName = 255
    lpName = Space(255)
    
    GetHandle = RegEnumKeyEx_(hKey, Index, @lpName, @lpcbName, 0, 0, 0, @lpftLastWriteTime)
    If GetHandle = #ERROR_SUCCESS
      ListSubKey = Left(lpName, lpcbName)
    EndIf
  EndIf
  RegCloseKey_(hKey)
  ;Reg_ListVal = ListSubKey
  ProcedureReturn ListSubKey
EndMacro
ProcedureDLL.s ListRegSubKey(regKey.s, Index.l) 
  Protected ComputerName.s = ""
  M_ListRegSubKey()
EndProcedure
ProcedureDLL.s ListRegSubKey2(regKey.s, Index.l, ComputerName.s) 
  M_ListRegSubKey()
EndProcedure


;/ Renvoi la sous-cl a l'indice specifie
Macro M_CountRegSubKey()
  Protected i.l, s$
  i = 0
  s$ = ListRegSubKey2(regKey, i, ComputerName)
  While s$ <> ""
    i + 1
    s$ = ListRegSubKey2(regKey, i, ComputerName)
  Wend
  ProcedureReturn i
EndMacro
ProcedureDLL.l CountRegSubKey(regKey.s)
  Protected ComputerName.s = ""
  M_CountRegSubKey()
EndProcedure
ProcedureDLL.l CountRegSubKey2(regKey.s, ComputerName.s) 
  M_CountRegSubKey()
EndProcedure


;/ Supprime une cl
Macro M_DeleteRegKeyValue()
  Protected GetHandle.l, hKey.l, lReturnCode.l, lhRemoteRegistry.l, DeleteValue.l
  Protected reg.Reg
  
  SplitRegKey(regKey, reg.Reg)
  GetHandle = IniForQueryToRegKey(reg, @ComputerName, @hKey, @lhRemoteRegistry) 
  
  If GetHandle = #ERROR_SUCCESS
    GetHandle = RegDeleteValue_(hKey, @reg\KeyValue)
    If GetHandle = #ERROR_SUCCESS
      DeleteValue = #True
    Else
      DeleteValue = #False
    EndIf
  EndIf
  RegCloseKey_(hKey)
  ProcedureReturn DeleteValue
EndMacro
ProcedureDLL.l DeleteRegKeyValue(regKey.s)
  Protected ComputerName.s = ""
  M_DeleteRegKeyValue()
EndProcedure 
ProcedureDLL.l DeleteRegKeyValue2(regKey.s, ComputerName.s) 
  M_DeleteRegKeyValue()
EndProcedure 


;/ Creation d'une cl
Macro M_CreateRegKey()
  Protected hNewKey.l, lpSecurityAttributes.SECURITY_ATTRIBUTES 
  Protected GetHandle.l, lReturnCode.l, lhRemoteRegistry.l, CreateKey.l
  Protected reg.Reg
  
  PathAddBackslash_(regKey)
  SplitRegKey(regKey, reg.Reg)
  
  If Left(reg\KeyName, 1) = "\" 
    reg\KeyName = Right(reg\KeyName, Len(reg\KeyName) - 1) 
  EndIf 
  
  If ComputerName = "" 
    GetHandle = RegCreateKeyEx_(reg\TopKey, reg\KeyName, 0, 0, #REG_OPTION_NON_VOLATILE, #KEY_ALL_ACCESS, @lpSecurityAttributes, @hNewKey, @GetHandle) 
  Else 
    lReturnCode = RegConnectRegistry_(ComputerName, reg\TopKey, @lhRemoteRegistry) 
    GetHandle = RegCreateKeyEx_(lhRemoteRegistry, reg\KeyName, 0, 0, #REG_OPTION_NON_VOLATILE, #KEY_ALL_ACCESS, @lpSecurityAttributes, @hNewKey, @GetHandle) 
  EndIf 
  
  If GetHandle = #ERROR_SUCCESS 
    GetHandle = RegCloseKey_(hNewKey)
    CreateKey = #True
  Else 
    CreateKey = #False
  EndIf 
  ProcedureReturn CreateKey 
EndMacro
ProcedureDLL.l CreateRegKey(regKey.s) 
  Protected ComputerName.s = ""
  M_CreateRegKey()
EndProcedure 
ProcedureDLL.l CreateRegKey2(regKey.s, ComputerName.s) 
  M_CreateRegKey()
EndProcedure 


;/ Supprime une cl
Macro M_DeleteRegKey()
  Protected GetHandle.l, lReturnCode.l, lhRemoteRegistry.l, DeleteKey.l
  Protected reg.Reg
  
  PathAddBackslash_(regKey)
  SplitRegKey(regKey, reg.Reg)
  
  If Left(reg\KeyName, 1) = "\" 
    reg\KeyName = Right(reg\KeyName, Len(reg\KeyName) - 1) 
  EndIf 
  
  If ComputerName = ""
    GetHandle = RegDeleteKey_(reg\TopKey, reg\KeyName) 
  Else 
    lReturnCode = RegConnectRegistry_(ComputerName, reg\TopKey, @lhRemoteRegistry) 
    GetHandle = RegDeleteKey_(lhRemoteRegistry, reg\KeyName) 
  EndIf 
  
  If GetHandle = #ERROR_SUCCESS 
    DeleteKey = #True 
  Else 
    DeleteKey = #False 
  EndIf 
  ProcedureReturn DeleteKey 
EndMacro
ProcedureDLL.l DeleteRegKey(regKey.s) 
  Protected ComputerName.s = ""
  M_DeleteRegKey()
EndProcedure
ProcedureDLL.l DeleteRegKey2(regKey.s, ComputerName.s) 
  M_DeleteRegKey()
EndProcedure 


;/ Renvoi les valeurs des cles a l'indice specifie
Macro M_ListRegSubValue()
  Protected GetHandle.l, hKey.l, dwIndex.l, lpName.s, lpcbName.l, ListSubValue.s
  Protected lhRemoteRegistry.l, lReturnCode.l, lpftLastWriteTime.FILETIME 
  Protected reg.Reg
  
  PathAddBackslash_(regKey)
  SplitRegKey(regKey, reg.Reg)
  GetHandle = IniForQueryToRegKey(reg, @ComputerName, @hKey, @lhRemoteRegistry)
  
  If GetHandle = #ERROR_SUCCESS
    lpcbName = 255
    lpName = Space(255)
    
    GetHandle = RegEnumValue_(hKey, Index, @lpName, @lpcbName, 0, 0, 0, 0)
    
    If GetHandle = #ERROR_SUCCESS
      ListSubValue = Left(lpName, lpcbName)
    Else
      ListSubValue = ""
    EndIf
    RegCloseKey_(hKey)
  EndIf
  ProcedureReturn ListSubValue
EndMacro
ProcedureDLL.s ListRegSubValue(regKey.s, Index.l) 
  Protected ComputerName.s = ""
  M_ListRegSubValue()
EndProcedure
ProcedureDLL.s ListRegSubValue2(regKey.s, Index.l, ComputerName.s) 
  M_ListRegSubValue()
EndProcedure


;/ Compte le nombre de 
Macro M_CountRegSubValue()
  Protected i.l, s$
  i = 0
  s$ = ListRegSubValue2(regKey, i, ComputerName)
  While s$ <> ""
    i + 1
    s$ = ListRegSubValue2(regKey, i, ComputerName)
  Wend
  ProcedureReturn i
EndMacro
ProcedureDLL.l CountRegSubValue(regKey.s)
  Protected ComputerName.s = ""
  M_CountRegSubValue()
EndProcedure
ProcedureDLL.l CountRegSubValue2(regKey.s, ComputerName.s) 
  M_CountRegSubValue()
EndProcedure


;/ Test l'existance d'une cl ou d'une valeur
Macro M_IsRegKey()
  Protected hKey.l, lhRemoteRegistry.l, lReturnCode.l, KeyExists.b
  Protected reg.Reg
  
  PathAddBackslash_(regKey)
  SplitRegKey(regKey, reg.Reg)
  
  If IniForQueryToRegKey(reg, @ComputerName, @hKey, @lhRemoteRegistry) = #ERROR_SUCCESS
    KeyExists = #True
  Else
    KeyExists = #False
  EndIf
  
  RegCloseKey_(hKey)
  ProcedureReturn KeyExists
EndMacro
ProcedureDLL.l IsRegKey(regKey.s)
  Protected ComputerName.s = ""
  M_IsRegKey()
EndProcedure
ProcedureDLL.l IsRegKey2(regKey.s, ComputerName.s) 
  M_IsRegKey()
EndProcedure

;/ 
Macro M_IsSubValue()
  Protected hKey.l, lhRemoteRegistry.l, lReturnCode.l, KeyExists.b
  Protected GetHandle.l, lpcbData.l, lpData.s, lType.l
  Protected reg.Reg
  
  SplitRegKey(regKey, reg.Reg)
  
  GetHandle = IniForQueryToRegKey(reg, @ComputerName, @hKey, @lhRemoteRegistry)
  
  If GetHandle = #ERROR_SUCCESS 
    lpcbData = 255
    lpData = Space(255)
    
    GetHandle = RegQueryValueEx_(hKey, reg\KeyValue, 0, @lType, @lpData, @lpcbData)
    If IsKeyValueType(lType) = #False
      lType = #False
    EndIf
  Else
    lType = #False
  EndIf
  
  RegCloseKey_(hKey)
  ProcedureReturn lType
EndMacro
ProcedureDLL.l IsSubValue(regKey.s)
  Protected ComputerName.s = ""
  M_IsSubValue()
EndProcedure
ProcedureDLL.l IsSubValue2(regKey.s, ComputerName.s) 
  M_IsSubValue()
EndProcedure


; IDE Options = PureBasic 4.30 (Windows - x86)
; CursorPosition = 117
; FirstLine = 130
; Folding = --------